import 'package:flutter/services.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:sariska_media_flutter_sdk/SariskaMediaTransportMethodChannel.dart';

void main() {
  TestWidgetsFlutterBinding.ensureInitialized();

  SariskaMediaTransportMethodChannel platform = SariskaMediaTransportMethodChannel();
  const MethodChannel channel = MethodChannel('sariska_media_flutter_sdk');

  setUp(() {
    TestDefaultBinaryMessengerBinding.instance.defaultBinaryMessenger.setMockMethodCallHandler(
      channel,
          (MethodCall methodCall) async {
        return '42';
      },
    );
  });

  tearDown(() {
    TestDefaultBinaryMessengerBinding.instance.defaultBinaryMessenger.setMockMethodCallHandler(channel, null);
  });

  test('getPlatformVersion', () async {
    expect(await platform.getPlatformVersion(), '42');
  });
}
